
#include "AppEvent.Ch"
#include "Common.Ch"
#include "DcBitMap.Ch"
#include "DcCursor.Ch"
#include "DcDialog.Ch"
#include "DcGra.Ch"
#include "DcIcon.Ch"
#include "Font.Ch"
#include "Gra.Ch"
#include "Inkey.Ch"
#include "Psst.Ch"
#include "Set.Ch"
#include "Thread.Ch"
#include "TopDown.Ch"
#include "Xbp.Ch"
#include "XbpDev.Ch"

#define VK_NUMLOCK        0x90
#define VK_SCROLL         0x91
#define VK_CAPITAL        0x14
#define APPKEY_PRESSED    2

FUNCTION Ptp117()

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8], cSeek := Space(25), oGet, oMsgBox

  PrgSecurity(@aSecurity, @aPtMenu01, "PTP117", GetList)

  SELECT CodeMst
  SET ORDER TO 1
  SELECT StatMst
  SET ORDER TO 1
  SELECT MemoDtl
  SET ORDER TO 1
  SELECT ParkOwn
  SET ORDER TO 1
  SELECT ParkMst
  SET ORDER TO 1
  DbGoTop()

  aTags            := ParkMst->(DC_RecTagArray())

  nCitation        := 0

  cOwnSex          := Space(1)
  cOwnRace         := Space(1)
  cOwnRaceDesc     := Space(10)
  cOwnSocial       := Space(11)
  dOwnDob          := CtoD('')
  lOwnCdl          := .f.
  cOwnDln          := Space(25)
  cOwnDlnState     := Space(2)
  nOwnDlnMm        := 0
  nOwnDlnYr        := 0
  nOwnAge          := 0
  cOwnName         := Space(40)
  cOwnAddress      := Space(40)
  cOwnUnit         := Space(8)
  cOwnCity         := Space(25)
  cOwnState        := Space(2)
  cOwnZip          := Space(10)
  cOwnHphone       := Space(13)
  cOwnWphone       := Space(13)

  cLicNo           := Space(10)                              // Citation - Vehicle
  cLicState        := Space(2)
  cVin             := Space(20)

  lPerson          := .f.
  lVehicle         := .f.

  bGetCitation     := {|| GetData117(GetList), DC_GetRefresh(GetList,, DCGETREFRESH_TYPE_EXCLUDE, {GETLIST_BROWSE} ) }

  aPres            := DC_BrowPres()
  aSort            := DC_BrowseSort()

  aBrowPres        := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                       { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                       { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                       { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                       { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                       { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                       { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                       { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                       { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                       { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                       { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                       { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                       { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                       { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                       { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                       { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                       { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                       { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                       { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
                      }

  aSort2[1]        := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2]        := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3]        := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4]        := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7]        := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8]        := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select


  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)

  @  0.00,  1.00 DCGROUP oGroup1        CAPTION ' Owner Information '                SIZE 100.00, 8.75                                                               COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  -.25, 18.50 DCCHECKBOX lPerson     PROMPT ' Consolidate Respondent Data '                                                                   PARENT oGroup1      COLOR GRA_CLR_RED, GRA_CLR_BACKGROUND ;
                 ID "Get_lPerson" ;
                 TABGROUP XBP_BEGIN_GROUP ;
                 CURSOR { Nil, POINTER_PEN_1, Nil } ;
                 MESSAGE 'Perform Consolidation to Respondent Information.' INTO oMsgBox

  @  1.25,  1.00 DCSAY 'D/L Number'                                                  SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.00, 14.00 DCGET cOwnDln                   Picture '!XXXXXXXXXXXXXXXXXXXXXXXX'                                                             PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  1.25, 46.00 DCSAY 'State'                                                       SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.00, 57.00 DCGET cOwnDlnState              Picture '!!'                                                                                    PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  1.25, 65.00 DCSAY 'Expires (MM/YYYY)'                                           SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.25, 82.50 DCSAY {|| nOwnDlnMm }                                               SAYSIZE  3              SAYFONT '10.Helv Bold'              PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  1.25, 85.10 DCSAY '/'                                                           SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  1.25, 86.50 DCSAY {|| nOwnDlnYr }                                               SAYSIZE  8              SAYFONT '10.Helv Bold'              PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  2.50, 14.00 DCSAY 'Race'                                                        SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  2.25, 20.00 DCGET cOwnRace                  Picture '!'                                                                                     PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  2.50, 26.00 DCSAY {|| cOwnRaceDesc }                                            SAYSIZE 10                                                  PARENT oGroup1      COLOR GRA_CLR_BLUE ;
			  		  WHEN {|| !Empty(cOwnRace) }

  @  2.50, 46.00 DCSAY 'Gender'                                                      SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  2.25, 57.00 DCGET cOwnSex                   Picture '!'                                                                                     PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  2.50, 65.00 DCSAY 'Birth Date'                                                  SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  2.25, 81.50 DCGET dOwnDob                   Picture '@D'                                                                                    PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  2.50, 77.25 DCSAY {|| nOwnAge }             Picture '999'                       SAYSIZE  3                                                  PARENT oGroup1      COLOR GRA_CLR_BLUE ;
			  		  HIDE {|| nOwnAge == 0 }

  @  3.75,  1.00 DCSAY 'Name'                                                        SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  3.50, 14.00 DCGET cOwnName                  Picture '!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'                                              PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					  PROPER

  @  3.75, 65.00 DCSAY 'Social Security No.'                                         SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  3.75, 81.50 DCSAY {|| cOwnSocial }                                              SAYSIZE 15              SAYFONT '10.Helv Bold'              PARENT oGroup1      COLOR GRA_CLR_DARKGREEN
//  @  3.75, 81.50 DCSAY {|| Repl('*',Len(AllTrim(cOwnSocial))) }                      SAYSIZE 15              SAYFONT '10.Helv Bold'              PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  5.00,  1.00 DCSAY 'Address'                                                     SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  5.00, 14.00 DCSAY {|| cOwnAddress }                                             SAYSIZE 30              SAYFONT '10.Helv Bold'              PARENT oGroup1      COLOR GRA_CLR_BLUE
  @  4.75, 14.00 DCGET cOwnAddress               Picture '!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'                                              PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					  PROPER

  @  5.00, 65.00 DCSAY 'Unit Number'                                                 SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  4.75, 81.50 DCGET cOwnUnit                  Picture '!!!!!!!!'                                                                              PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  6.25,  1.00 DCSAY 'City'                                                        SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  6.00, 14.00 DCGET cOwnCity                  Picture '!XXXXXXXXXXXXXXXXXXXXXXXX'                                                             PARENT oGroup1      COLOR GRA_CLR_BLUE ;
					  PROPER

  @  6.25, 46.00 DCSAY 'State'                                                       SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  6.00, 57.00 DCGET cOwnState                 Picture '!!'                                                                                    PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  6.25, 65.00 DCSAY 'Zip Code'                                                    SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  6.00, 81.50 DCGET cOwnZip                   Picture '99999'                                                                                 PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  7.50,  1.00 DCSAY 'Home Telephone'                                              SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  7.25, 14.00 DCGET cOwnHphone                Picture '(999)999-9999'                                                                         PARENT oGroup1      COLOR GRA_CLR_BLUE

  @  7.50, 65.00 DCSAY 'Work Telephone'                                              SIZE  0                                                     PARENT oGroup1      COLOR GRA_CLR_BLACK
  @  7.25, 81.50 DCGET cOwnWphone                Picture '(999)999-9999'                                                                         PARENT oGroup1      COLOR GRA_CLR_BLUE


  @  0.00,102.50 DCGROUP oGroup2        CAPTION ' Vehicle Information '              SIZE 48.00, 3.75                                                                COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  -.25, 20.00 DCCHECKBOX lVehicle    PROMPT ' Consolidate Vehicle Data '                                                                      PARENT oGroup2      COLOR GRA_CLR_RED, GRA_CLR_BACKGROUND ;
                 ID "Get_lVehicle" ;
                 TABGROUP XBP_BEGIN_GROUP ;
                 CURSOR { Nil, POINTER_PEN_1, Nil } ;
                 MESSAGE 'Perform Consolidation to Vehicle Information.' INTO oMsgBox

  @  1.25,  1.00 DCSAY 'License Number'                                              SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK
  @  1.00, 14.00 DCGET cLicNo                    Picture '@!'                                                                                    PARENT oGroup2      COLOR GRA_CLR_BLUE ;

  @  1.25, 29.00 DCSAY 'State'                                                       SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK
  @  1.00, 34.50 DCGET cLicState                 Picture '!!'                                                                                    PARENT oGroup2      COLOR GRA_CLR_BLUE ;

  @  2.50,  1.00 DCSAY 'VIN'                                                         SIZE  0                                                     PARENT oGroup2      COLOR GRA_CLR_BLACK
  @  2.25, 14.00 DCGET cVin                      Picture '@!'                                                                                    PARENT oGroup2      COLOR GRA_CLR_BLUE ;


  @  5.00,103.50 DCSAY "Search:"                                                     SIZE  0
  @  4.75,116.00 DCGET cSeek                     Picture '@!' ;
                 GETID 'oSeek' ;
			        GETOBJECT oGet ;
                 KEYBLOCK {|a,b,o| _Ptp117( a, b, o, oBrowse, @cSeek ) }

  @  9.25,  1.00 DCBROWSE oBrowse ALIAS 'ParkMst'                                    SIZE 50,20 ;
  			        FIT ;
			        NOHSCROLL ;
			  		  NOTABSTOP ;
			        HEADLINES 2 ;
  			        NOSOFTTRACK ;
                 TAGENABLE ;
                   TAGMODE DCGUI_TAGMODE_SET ;
                   TAGCOLOR GRA_CLR_RED, GRA_CLR_YELLOW ;
                 PRESENTATION DC_BrowPres() ;
			        CURSORMODE XBPBRW_CURSOR_ROW ;
                 SORTUPBITMAP BITMAP_RD_UP_RED ;
                 SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                 SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                 SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
					  ITEMSELECTED bGetCitation

//					  ITEMSELECTED { || GetData117(GetList), DC_GetRefresh(GetList,, DCGETREFRESH_TYPE_EXCLUDE, {GETLIST_BROWSE} ) }


  DCBROWSECOL    DATA {|| ParkMst->T_Number }                                        HEADER 'Citation;Number'           WIDTH  6     PARENT oBrowse ;
  	              PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                 SORT {|| OrdSetFocus('PARKMX01') } LEFTBUTTON ;
                 _DEFAULT OrdSetFocus() == 'PARKMX01'

  DCBROWSECOL    DATA {|| Trim(ParkMst->Name) }                                      HEADER ';Owner / Driver Name'      WIDTH 16     PARENT oBrowse ;
  	              PRESENTATION { {XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                 SORT {|| OrdSetFocus('PARKMX04') } LEFTBUTTON

  DCBROWSECOL    DATA {|| Trim(ParkMst->Address) }                                   HEADER ';Respondent Address'       WIDTH 13     PARENT oBrowse

  DCBROWSECOL    DATA {|| Trim(ParkMst->City) }                                      HEADER ';Respondent City'          WIDTH 10     PARENT oBrowse

  DCBROWSECOL    DATA {|| Trim(ParkMst->State) }                                     HEADER ';State'                    WIDTH  3     PARENT oBrowse ;
					  ALIGN 5

  DCBROWSECOL    DATA {|| ParkMst->Sex }                                             HEADER ';Sex'                      WIDTH  3     PARENT oBrowse ;
					  ALIGN 5

  DCBROWSECOL    DATA {|| ParkMst->Dob }                                             HEADER 'Date of;Birth'             WIDTH  6     PARENT oBrowse ;
					  ALIGN 5

  DCBROWSECOL    DATA {|| ParkMst->Dln }                                             HEADER ';Drivers License'          WIDTH 10     PARENT oBrowse ;
  	              PRESENTATION { {XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                 SORT {|| OrdSetFocus('PARKMX15') } LEFTBUTTON

  DCBROWSECOL    DATA {|| ParkMst->LicNo }                                           HEADER 'License;Number'            WIDTH  7     PARENT oBrowse ;
  	              PRESENTATION { {XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                 SORT {|| OrdSetFocus('PARKMX07') } LEFTBUTTON

  DCBROWSECOL    DATA {|| ParkMst->Vin }                                             HEADER ';VIN'                      WIDTH 13     PARENT oBrowse ;
  	              PRESENTATION { {XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                 SORT {|| OrdSetFocus('PARKMX10') } LEFTBUTTON


  @ 29.75,11.50  DCPUSHBUTTON           CAPTION 'Consolidate'                        SIZE 12, 1.25 ;
					  CARGO "CANCEL" ;
                 ACTION {|| Consolidate(1, GetList, oBrowse) } ;
                 WHEN {|| lPerson .AND. aSecurity[2] .OR. lVehicle .AND. aSecurity[2] } ;
                 TOOLTIP 'Consolidate Displayed Respondent Information to Selected Citations.'

  @ 29.75,35.00  DCPUSHBUTTON           CAPTION 'Cancel'                             SIZE 10, 1.25 ;
					  CARGO "CANCEL" ;
                 ACTION {|| Consolidate(0, GetList, oBrowse) }

  @ 29.75,55.00  DCPUSHBUTTON           CAPTION 'Exit'                               SIZE 10, 1.25 ;
					  CARGO "CANCEL" ;
                 ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }


  DCGETOPTIONS ;
    CASCADE ;
	 NOMAXBUTTON ;
    SOURCEFILE __FILEPATH__

  DCREAD GUI ;
         FIT ;
			OPTIONS GetOptions ;
	      TITLE ' Respondent / Vehicle Consolidation ' ;
         EVAL { || SetAppFocus(DC_GetObject(GetList,"oSeek")) }


RETURN Nil

*---

STATIC FUNCTION Consolidate( nAction, GetList )

  DO CASE

	 CASE nAction == 0

      cOwnSex          := Space(1)
      cOwnRace         := Space(1)
      cOwnRaceDesc     := Space(10)
      cOwnSocial       := Space(11)
      dOwnDob          := CtoD('')
      lOwnCdl          := .f.
      cOwnDln          := Space(25)
      cOwnDlnState     := Space(2)
      nOwnDlnMm        := 0
      nOwnDlnYr        := 0
      nOwnAge          := 0
      cOwnName         := Space(40)
      cOwnAddress      := Space(40)
      cOwnUnit         := Space(8)
      cOwnCity         := Space(25)
      cOwnState        := Space(2)
      cOwnZip          := Space(10)
      cOwnHphone       := Space(13)
      cOwnWphone       := Space(13)

      cLicNo           := Space(10)                              // Citation - Vehicle
      cLicState        := Space(2)
      cVin             := Space(20)

      lPerson          := .f.
      lVehicle         := .f.

      DC_RecTagClear()
      DC_GetRefresh(GetList)

	 CASE nAction == 1

      IF DC_MsgBox(,,{'Consolidate Respondent Information ?'},"Respondent Information Consolidation",,,.t.,2,,,,,,,12)

        SELECT ParkMst
  	 	  lUpdate := .f.
        nRecord := RecNo()
        nOrder  := OrdNumber()
  	 	  SET ORDER TO 1
        FOR i := 1 TO Len(aTags)
          ParkMst->(DbGoTo(aTags[i]))
  	 	 	 IF !Eof()
            IF DC_RecLock(5)                                    // Update Record Text

  	 	 		  IF lPerson
					 cOwnOper     := ParkMst->OwnOper
					 nCitation    := ParkMst->T_Number
  	 	 			 cConsolidate := "Respondent Information:" + Chr(13) + Chr(10)
  	 	 			 IF ParkMst->Name <> cOwnName
  	 	 			   cConsolidate := cConsolidate + "Name Changed From: " + AllTrim(ParkMst->Name) + " to " + AllTrim(cOwnName) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->Address <> cOwnAddress
  	 	 				cConsolidate := cConsolidate + "Address Changed From: " + AllTrim(ParkMst->Address) + " to " + AllTrim(cOwnAddress) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->Unit <> cOwnUnit
  	 	 				cConsolidate := cConsolidate + "Unit Changed From: " + AllTrim(ParkMst->Unit) + " to " + AllTrim(cOwnUnit) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->City <> cOwnCity
  	 	 				cConsolidate := cConsolidate + "City Changed From: " + AllTrim(ParkMst->City) + " to " + AllTrim(cOwnCity) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->State <> cOwnState
  	 	 				cConsolidate := cConsolidate + "State Changed From: " + AllTrim(ParkMst->State) + " to " + AllTrim(cOwnState) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->Zip <> cOwnZip
  	 	 				cConsolidate := cConsolidate + "Zip Code Changed From: " + AllTrim(ParkMst->Zip) + " to " + AllTrim(cOwnZip) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->HPhone <> cOwnHphone
  	 	 				cConsolidate := cConsolidate + "Home Telephone Changed From: " + AllTrim(ParkMst->HPhone) + " to " + AllTrim(cOwnHphone) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->WPhone <> cOwnWphone
  	 	 				cConsolidate := cConsolidate + "Work Telephone Changed From: " + AllTrim(ParkMst->WPhone) + " to " + AllTrim(cOwnWphone) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->Sex <> cOwnSex
  	 	 				cConsolidate := cConsolidate + "Sex Changed From: " + AllTrim(ParkMst->Sex) + " to " + AllTrim(cOwnSex) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->Dln <> cOwnDln
  	 	 				cConsolidate := cConsolidate + "DLN Changed From: " + AllTrim(ParkMst->Dln) + " to " + AllTrim(cOwnDln) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->Dob <> dOwnDob
  	 	 				cConsolidate := cConsolidate + "DOB Changed From: " + DtoC(ParkMst->Dob) + " to " + DtoC(dOwnDob) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->DlnState <> cOwnDlnState
  	 	 				cConsolidate := cConsolidate + "DLN State Changed From: " + AllTrim(ParkMst->DlnState) + " to " + AllTrim(cOwnDlnState) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->DlnMm <> nOwnDlnMm
  	 	 				cConsolidate := cConsolidate + "DLN Expiration Month Changed From: " + Str(ParkMst->DlnMm,2,0) + " to " + Str(nOwnDlnMm,2,0) + Chr(13) + Chr(10)
  	 	 			 ENDIF
  	 	 			 IF ParkMst->DlnYr <> nOwnDlnYr
  	 	 				cConsolidate := cConsolidate + "DLN Expiration Year Changed From: " + Str(ParkMst->DlnYr,4,0) + " to " + Str(nOwnDlnYr,4,0) + Chr(13) + Chr(10)
  	 	 			 ENDIF
				  ENDIF

				  IF lVehicle
					 IF lPerson
  	 	 			   cConsolidate := cConsolidate + Chr(13) + Chr(10) + "Vehicle Information:" + Chr(13) + Chr(10)
					 ELSE
  	 	 			   cConsolidate := "Respondent Information:" + Chr(13) + Chr(10)
					 ENDIF
  	 	 			 IF ParkMst->LicNo <> cLicNo .OR. ParkMst->LicState <> cLicState .OR. ParkMst->Vin <> cVin
  	 	 				cConsolidate := cConsolidate + Chr(13) + Chr(10) + "Vehicle Information:" + Chr(13) + Chr(10)
  	 	 			   IF ParkMst->LicNo <> cLicNo
  	 	 				  cConsolidate := cConsolidate + "Vehicle License Number Changed From: " + ParkMst->LicNo + " to " + cLicNo + Chr(13) + Chr(10)
  	 	 				ENDIF
  	 	 				IF ParkMst->LicState <> cLicState
  	 	 				  cConsolidate := cConsolidate + "Vehicle License State Changed From: " + ParkMst->LicState + " to " + cLicState + Chr(13) + Chr(10)
  	 	 				ENDIF
  	 	 				IF ParkMst->Vin <> cVin
  	 	 				  cConsolidate := cConsolidate + "Vehicle VIN Changed From: " + ParkMst->Vin + " to " + cVin
  	 	 				ENDIF
  	 	 			 ENDIF
				  ENDIF

				  IF lPerson
  	 	 	       lUpdate := .t.
                REPLACE Name           WITH cOwnName
                REPLACE Address        WITH cOwnAddress
                REPLACE Unit           WITH cOwnUnit
                REPLACE City           WITH cOwnCity
                REPLACE State          WITH cOwnState
                REPLACE Zip            WITH cOwnZip
                REPLACE HPhone         WITH cOwnHphone
                REPLACE WPhone         WITH cOwnWphone
                REPLACE Sex            WITH cOwnSex
                REPLACE Dob            WITH dOwnDob
                REPLACE Social         WITH ENCRYPT(cOwnSocial)
                REPLACE Dln            WITH cOwnDln
                REPLACE DlnState       WITH cOwnDlnState
                REPLACE DlnMm          WITH nOwnDlnMm
                REPLACE DlnYr          WITH nOwnDlnYr
				  ENDIF

  	 	 		  IF lVehicle
  	 	 	       lUpdate := .t.
                REPLACE LicNo          WITH cLicNo
                REPLACE LicState       WITH cLicState
                REPLACE Vin            WITH cVin
  	 	 		  ENDIF
  	 	 		  UNLOCK

  	 	 		  IF lUpdate
					 SELECT ParkOwn
					 IF lPerson
		            SEEK Str(nCitation,10,0) + cOwnOper                   //  [O]wner / [D]river / [L]essor / [R]enter (Lessee)
						IF !Eof()
                    IF DC_RecLock(5)                                    // Update Record Text
                      REPLACE Name     WITH cOwnName
                      REPLACE Address  WITH cOwnAddress
                      REPLACE Unit     WITH cOwnUnit
                      REPLACE City     WITH cOwnCity
                      REPLACE State    WITH cOwnState
                      REPLACE Zip      WITH cOwnZip
                      REPLACE HPhone   WITH cOwnHphone
                      REPLACE WPhone   WITH cOwnWphone
                      REPLACE Sex      WITH cOwnSex
                      REPLACE Dob      WITH dOwnDob
                      REPLACE Social   WITH ENCRYPT(cOwnSocial)
                      REPLACE Dln      WITH cOwnDln
                      REPLACE DlnState WITH cOwnDlnState
                      REPLACE DlnMm    WITH nOwnDlnMm
                      REPLACE DlnYr    WITH nOwnDlnYr
  	 	 		          UNLOCK
  	 	 		        ENDIF
  	 	 		      ENDIF
  	 	 		    ENDIF

                SELECT StatMst
                SET ORDER TO 1
                SEEK Str(ParkMst->T_Number,10,0) + "~DC~" + DtoS(Date())
                IF Eof()
                  APND()
                ENDIF
                IF DC_RecLock(5)                                    // Update Record Text
                  REPLACE T_Number     WITH ParkMst->T_Number
                  REPLACE S_Date       WITH Date()
                  REPLACE S_Code       WITH "~DC~"
                  REPLACE X_Code       WITH ParkMst->XCode
  	 	 		      REPLACE A_Date       WITH Date()
  	 	 		      REPLACE A_Time       WITH Time()
  	 	 		      REPLACE A_Oper       WITH nSecId
  	 	 		      REPLACE S_Text       WITH "Data Consolidation Performed"
  	 	 		      UNLOCK
                ENDIF

  	 	 		    SELECT MemoDtl
  	 	 		    SET ORDER TO 1
  	 	 		    SEEK "S" + Str(ParkMst->T_Number,10,0) + DtoS(Date())
  	 	 		    IF Eof()
  	 	 		      APND()
  	 	 		    ENDIF
  	 	 		    IF DC_RecLock(5)
                  REPLACE MemoKey      WITH "S" + Str(ParkMst->T_Number,10,0) + DtoS(Date())
                  REPLACE MemoText     WITH cConsolidate
  	 	 		      UNLOCK
  	 	 		    ENDIF
                SELECT ParkMst
  	 	 		  ENDIF

  	 	 		ENDIF

  	 	 	 ENDIF

        NEXT

      ENDIF

  	 	SELECT ParkMst
      SET ORDER TO nOrder
      ParkMst->(DbGoTo(nRecord))

      cOwnSex          := Space(1)
      cOwnRace         := Space(1)
      cOwnRaceDesc     := Space(10)
      cOwnSocial       := Space(11)
      dOwnDob          := CtoD('')
      lOwnCdl          := .f.
      cOwnDln          := Space(25)
      cOwnDlnState     := Space(2)
      nOwnDlnMm        := 0
      nOwnDlnYr        := 0
      nOwnAge          := 0
      cOwnName         := Space(40)
      cOwnAddress      := Space(40)
      cOwnUnit         := Space(8)
      cOwnCity         := Space(25)
      cOwnState        := Space(2)
      cOwnZip          := Space(10)
      cOwnHphone       := Space(13)
      cOwnWphone       := Space(13)

      cLicNo           := Space(10)                              // Citation - Vehicle
      cLicState        := Space(2)
      cVin             := Space(20)

      lPerson          := .f.
      lVehicle         := .f.

      DC_RecTagClear()
      aTags            := ParkMst->(DC_RecTagArray())

      DC_GetRefresh(GetList)

  ENDCASE

RETURN .t.

*---

STATIC FUNCTION _Ptp117( a, b, o, oBrowse, cSeek )

  LOCAL lClearBuffer := .t., lSoftSeek := Set(_SET_SOFTSEEK, .t.)

  IF     a == xbeK_UP
    oBrowse:up()
  ELSEIF a == xbeK_DOWN
    oBrowse:down()
  ELSEIF a == xbeK_PGUP
    oBrowse:pageUp()
  ELSEIF a == xbeK_PGDN
    oBrowse:pageDown()
  ELSEIF a == xbeK_END
    oBrowse:goBottom()
  ELSEIF a == xbeK_HOME
    oBrowse:goTop()
  ELSE
    SEEK AllTrim(o:EditBuffer())
    lClearBuffer := .f.
  ENDIF

  oBrowse:refreshAll()

  IF lClearBuffer
    cSeek := Space(30)
    o:Get:home()
    o:setData()
  ENDIF

  Set(_SET_SOFTSEEK,lSoftSeek)

RETURN Nil

*---

STATIC FUNCTION GetData117(GetList)

  cOwnName     := ParkMst->Name
  cOwnAddress  := ParkMst->Address
  cOwnUnit     := ParkMst->Unit
  cOwnCity     := ParkMst->City
  cOwnState    := ParkMst->State
  cOwnZip      := ParkMst->Zip
  cOwnHphone   := ParkMst->HPhone
  cOwnWphone   := ParkMst->WPhone
  cOwnSex      := ParkMst->Sex
  dOwnDob      := ParkMst->Dob
//  cOwnSocial   := DECRYPT(ParkMst->Social)
  cOwnSocial   := "***-**-****"
  cOwnDln      := ParkMst->Dln
  cOwnDlnState := ParkMst->DlnState
  nOwnDlnMm    := ParkMst->DlnMm
  nOwnDlnYr    := ParkMst->DlnYr

  cLicNo       := ParkMst->LicNo
  cLicState    := ParkMst->LicState
  cVin         := ParkMst->Vin

  cSeek        := Space(25)

RETURN Nil
